unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, OpenGLContext, LCLType, StdCtrls, Types, Math,

  {$ifdef arm}
  dglOpenGLSE,
  {$else}
  dglOpenGL,
  {$endif}

  Mesh, MyMath, Rad, Zylinder, Stange;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    OpenGLControl1: TOpenGLControl;
    Panel1: TPanel;
    Timer1: TTimer;
    ToggleBoxTimer: TToggleBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenGLControl1Paint(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ToggleBoxTimerChange(Sender: TObject);















  public
    Mesh: TMesh;

    SchieberZylinder: TZylinder;

    PleuelSchwinge1, PleuelSchwinge2, PleuelSchwinge3, PleuelSchwinge4: TStange;

    TreibRad: record
      Radius, WinkelSchwingeExcenter: single;
      Rad: TRad;
      SchwingeExzenterRadius, ExzenterRadius: single;
    end;

    Schubstange: record
      ZylinderAbstand: single;
      Schubstange, Pleuel, ZylinderStange: TStange;
      Zylinder: TZylinder
    end;

    Abstand: TPointf;
    RadAbstand, speed, winkel: single;
    procedure BackGround;
  end;

var
  Form1: TForm1;

implementation


{ TForm1 }

procedure TForm1.BackGround;
begin
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity();

  glBegin(GL_QUADS);
  glColor3f(0.4, 0.2, 0.3);
  glVertex3f(-1.0, -1.0, 0.999);
  glColor3f(0.45, 0.25, 0.3);
  glVertex3f(+1.0, -1.0, 0.999);
  glColor3f(0.4, 0.25, 0.53);
  glVertex3f(+1.0, +1.0, 0.999);
  glColor3f(0.45, 0.2, 0.35);
  glVertex3f(-1.0, +1.0, 0.999);
  glEnd();

  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  winkel += speed;
  if winkel > 360 then begin
    winkel -= 360;
  end;
  OpenGLControl1.Repaint;
end;

procedure TForm1.ToggleBoxTimerChange(Sender: TObject);
begin
  Timer1.Enabled := ToggleBoxTimer.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitOpenGL;
  ReadExtensions;
  ReadImplementationProperties;
  OpenGLControl1.MakeCurrent;


  with TreibRad do begin
    Radius := 500.0;
    ExzenterRadius := Radius * 0.65;
    SchwingeExzenterRadius := Radius * 0.4;
    WinkelSchwingeExcenter:=60.0;

    Rad := TRad.Create(Radius);

    Abstand.x := Radius * 2.4;
    Abstand.y := 300.0;
    RadAbstand := Radius * 2.4;
  end;

  with Schubstange do begin
    ZylinderAbstand := Abstand.x;
    Schubstange := TStange.Create(TreibRad.Radius / 8, RadAbstand, vec3(1.0, 0.2, 0.2));
    Pleuel := TStange.Create(TreibRad.Radius / 8, RadAbstand, vec3(1.0, 0.2, 0.2));
    ZylinderStange := TStange.Create(TreibRad.Radius / 8, Abstand.x / 2, vec3(1.0, 0.2, 0.2));
    Zylinder := TZylinder.Create(TreibRad.ExzenterRadius * 2, TreibRad.ExzenterRadius * 2);
  end;


  Mesh := TMesh.Create;
  SchieberZylinder := TZylinder.Create(TreibRad.SchwingeExzenterRadius * 2, TreibRad.SchwingeExzenterRadius * 2);

  with Schubstange do begin
  end;

  PleuelSchwinge1 := TStange.Create(TreibRad.Radius / 24, Abstand.x * 0.85, vec3(0.2, 1.0, 0.2));
  PleuelSchwinge2 := TStange.Create(TreibRad.Radius / 24, Abstand.x / 2.1, vec3(0.2, 0.2, 1.0));
  PleuelSchwinge3 := TStange.Create(TreibRad.Radius / 24, Abstand.x / 1.2, vec3(1.0, 0.2, 0.2));
  PleuelSchwinge4 := TStange.Create(TreibRad.Radius / 24, Abstand.x / 2.3, vec3(1.0, 0.2, 0.2));
  speed := 3.01;

  Trigo.Grad := True;
  Timer1.Enabled := True;
end;

procedure TForm1.OpenGLControl1Paint(Sender: TObject);
var
  ExzenterSchubstange_xy, ExzenterSchwinge_xy: TPointf;
dif,  f, p,p2: single;
  Schwinge1, Schwinge2: TSchwinge;

begin
  glClearColor(0.4, 0.2, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  BackGround;

  glScalef(0.001, 0.001, 0.001);
  glTranslatef(-RadAbstand * 2, 0.0, 0.0);

  // --- Bremsklötze

  with TreibRad do begin
    glPushMatrix;
    Mesh.Arc(Radius * 1.2, Radius * 1.4, 0, 60); // deutet eine Schwinge1 an
    glColor3f(1, 1, 1);
    Mesh.Arc(Radius * 1.2, Radius * 1.4, 90, 180.0); // deutet eine Schwinge1 an
    glColor3f(1, 0.1, 1);
    if winkel < 180.0 then begin
      glRotatef(winkel / 10, 0.0, 0.0, 1.0);
    end else begin
      glRotatef(180.0 / 10 - (winkel / 10 - 180.0 / 10), 0.0, 0.0, 1.0);
    end;

    Mesh.Arc(Radius * 1.4, Radius * 1.6, -30, 30); // deutet eine Schwinge1 an
    glPopMatrix;
  end;

  // --- Treibrad


  with TreibRad do begin
    Rad.Draw(winkel);
    glTranslatef(RadAbstand, 0.0, 0.0);
    Rad.Draw(winkel);
    glTranslatef(RadAbstand, 0.0, 0.0);
    Rad.Draw(winkel);
  end;

  glPushMatrix;
  glTranslatef(0, 0, -0.03);

  // --- Schubstange

  with Schubstange do begin
    ExzenterSchubstange_xy := Trigo.Alpha_c_To_xy(winkel, TreibRad.ExzenterRadius);

    glTranslatef(ExzenterSchubstange_xy.x, ExzenterSchubstange_xy.y, 0);

    glPushMatrix;
    glTranslatef(-Abstand.x, 0.0, 0.0);
    Schubstange.Draw;
    glTranslatef(-Abstand.x, 0.0, 0.0);
    Schubstange.Draw;
    glPopMatrix;

    // --- Pleuel

    glRotatef(-Trigo.a_c_To_Alpha(ExzenterSchubstange_xy.y, Schubstange.Laenge), 0.0, 0.0, 1.0);
    Pleuel.Draw;
    glPopMatrix;

    // --- Zylinder

    glPushMatrix;
    p := sqrt(sqr(Schubstange.Laenge) - sqr(ExzenterSchubstange_xy.y)) + ExzenterSchubstange_xy.x;
    glTranslatef(p, 0.0, 0.0);
    ZylinderStange.Draw;
    glPopMatrix;

    glPushMatrix;

    glTranslatef(ZylinderAbstand + ZylinderStange.Laenge, 0.0, 0.0);

    f := p - Schubstange.Laenge + TreibRad.ExzenterRadius;
    Zylinder.Draw(f);

    glPopMatrix;

    // Zylinder Schieber

    glPushMatrix;

    ExzenterSchwinge_xy := Trigo.Alpha_c_To_xy(winkel+TreibRad.WinkelSchwingeExcenter, TreibRad.SchwingeExzenterRadius);
    p2 := sqrt(sqr(Schubstange.Laenge) - sqr(ExzenterSchwinge_xy.y)) + ExzenterSchwinge_xy.x;
    f := p2 - Schubstange.Laenge + TreibRad.ExzenterRadius-(TreibRad.ExzenterRadius-TreibRad.SchwingeExzenterRadius);


    dif:=f;
    p2:=Abstand.x+dif;

    glTranslatef(ZylinderAbstand + ZylinderStange.Laenge, 300.0, 0.0);
    SchieberZylinder.Draw(f);

    glPopMatrix;
  end;


  glPopMatrix;


  // --- Schwinge1 ---

//  Schwinge1.SetParam(winkel + TreibRad.WinkelSchwingeExcenter, TreibRad.SchwingeExzenterRadius, Abstand.x, Abstand.y, PleuelSchwinge1.Laenge, PleuelSchwinge2.Laenge);
  Schwinge1.SetParam(winkel + TreibRad.WinkelSchwingeExcenter, TreibRad.SchwingeExzenterRadius, p2, Abstand.y, PleuelSchwinge1.Laenge, PleuelSchwinge2.Laenge);


  // Pleuel

  glPushMatrix;

  glTranslatef(Schwinge1.RadExzenter.x, Schwinge1.RadExzenter.y, -0.2);
  glRotatef(Schwinge1.Pleuel_W, 0.0, 0.0, 1.0);
  PleuelSchwinge1.Draw;

  glPopMatrix;

  // Schwinge

  glPushMatrix;

//  glTranslatef(Abstand.x, Abstand.y, -0.2);
  glTranslatef(p2, Abstand.y, -0.2);
  glRotatef(Schwinge1.Schwinge_W, 0.0, 0.0, 1.0);
  PleuelSchwinge2.Draw;

  glPopMatrix;


  // --- Schwinge2 ---


//  Schwinge2.SetParam(Schwinge1.Schwinge_W, PleuelSchwinge2.Laenge / 2, p - Abstand.x / 2, Abstand.y - 600, PleuelSchwinge3.Laenge, PleuelSchwinge4.Laenge);
  Schwinge2.SetParam(Schwinge1.Schwinge_W, PleuelSchwinge2.Laenge / 2, p - (p2+dif)/2, Abstand.y - 600, PleuelSchwinge3.Laenge, PleuelSchwinge4.Laenge);

//  glPushMatrix;
//    glTranslatef(Abstand.x, Abstand.y, -0.2);
  glTranslatef(p2, Abstand.y, -0.2);

  // Pleuel

  glPushMatrix;

  glTranslatef(Schwinge2.RadExzenter.x, Schwinge2.RadExzenter.y, -0.2);
  glRotatef(Schwinge2.Pleuel_W, 0.0, 0.0, 1.0);
  PleuelSchwinge3.Draw;

  glPopMatrix;

  // Schwinge


  glPushMatrix;

  glTranslatef(p-(p2+dif)/2, Abstand.y - 600, -0.2);
//  glTranslatef(p - p2 / 2, Abstand.y - 600, -0.2);
  glRotatef(Schwinge2.Schwinge_W, 0.0, 0.0, 1.0);
  PleuelSchwinge4.Draw;

  glPopMatrix;


  glPopMatrix;


  OpenGLControl1.SwapBuffers;
end;

procedure TForm1.OpenGLControl1Resize(Sender: TObject);
begin
  with OpenGLControl1 do begin
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glScalef(Height / Width, 1.0, 1.0);
  end;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  with TreibRad do begin
    Rad.Free;
  end;
  SchieberZylinder.Free;
  Mesh.Free;
  with Schubstange do begin
    Schubstange.Free;
    Pleuel.Free;
    ZylinderStange.Free;
    Zylinder.Free;
  end;
  PleuelSchwinge1.Free;
  PleuelSchwinge2.Free;
  PleuelSchwinge3.Free;
  PleuelSchwinge4.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  speed *= 1.1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  speed /= 1.1;
end;

initialization

  {$I unit1.lrs}

end.
