unit Zylinder;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, dglOpenGL;

type

  { TZylinder }

  TZylinder = class(TObject)
  private
    fWidth, fmaxHub: single;
  public
    constructor Create(Width, maxHub: single);
    procedure Draw(HubPos: single);
  end;

implementation

{ TZylinder }

constructor TZylinder.Create(Width, maxHub: single);
begin
  inherited Create;
  fWidth := Width;
  fmaxHub := maxHub;
end;

procedure TZylinder.Draw(HubPos: single);
const
  h = 100;
var
  KolbenW,
  p: single;

begin
  KolbenW := fWidth / 100;

  glBegin(GL_QUADS);
  glColor3f(0.1, 0.1, 0.1);
  glVertex3f(0, -h, 0.1);
  glVertex3f(0, h, 0.1);

  glColor3f(0.2, 0.2, 0.2);
  glVertex3f(fWidth, h, 0.1);
  glVertex3f(fWidth, -h, 0.1);
  glEnd();

  //  p := fWidth / 100 * HubPos;
  p := fWidth / fmaxHub * HubPos;

  glBegin(GL_QUADS);
  glColor3f(0.7, 0.7, 0.7);
  glVertex3f(-KolbenW + p, -h, 0.0);
  glVertex3f(-KolbenW + p, h, 0.0);

  glColor3f(0.8, 0.8, 0.8);
  glVertex3f(KolbenW + p, h, 0.0);
  glVertex3f(KolbenW + p, -h, 0.0);
  glEnd();
end;

end.
